#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 200000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
int a[MAXN];
llong dp[MAXN];
int minDiv[MAXN];
int maxDiv[MAXN];

llong max_prize(std::vector <int> A)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    std::fill(minDiv + 1, minDiv + 1 + n, INTINF);
    for (int i = 2 ; i <= n ; ++i)
    {
        if (minDiv[i] != INTINF)
        {
            continue;
        }

        minDiv[i] = i;
        for (int j = 2 * i ; j <= n ; j += i)
        {
            minDiv[j] = std::min(minDiv[j], i);
        }
    }

    for (int i = 2 ; i <= n ; ++i)
    {
        maxDiv[i] = minDiv[i];
        maxDiv[i] = std::max(maxDiv[i], i / minDiv[i]);
        if (i == minDiv[i])
        {
           maxDiv[i] = 1;
        }

        minDiv[i] = 1;
    }

    dp[n] = 0;
    llong ans = 0;
    for (int i = n - 1 ; i >= 1 ; --i)
    {
        dp[i] = -INF;
        for (int next = i + 2 ; next <= n ; ++next)
        {
            if (a[next] < 0)
            {
                dp[i] = std::max(dp[i], dp[next] + 1LL * minDiv[next - i] * a[next]);
            } else
            {
                dp[i] = std::max(dp[i], dp[next] + 1LL * maxDiv[next - i] * a[next]);
            }
        }
    }

    return dp[1];
}
