#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <set>

typedef long long llong;
const int MAXN = 200000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
int a[MAXN];
llong dp[MAXN];
int minDiv[MAXN];
int maxDiv[MAXN];
std::set <std::pair <llong,int>> s;

llong max_prize(std::vector <int> A)
{
    n = A.size();
    for (int i = 1 ; i <= n ; ++i)
    {
        a[i] = A[i - 1];
    }

    std::fill(minDiv + 1, minDiv + 1 + n, INTINF);
    for (int i = 2 ; i <= n ; ++i)
    {
        if (minDiv[i] != INTINF)
        {
            continue;
        }

        minDiv[i] = i;
        for (int j = 2 * i ; j <= n ; j += i)
        {
            minDiv[j] = std::min(minDiv[j], i);
        }
    }

    for (int i = 2 ; i <= n ; ++i)
    {
        maxDiv[i] = i / minDiv[i];
        minDiv[i] = 1;
    }

    dp[n] = 0;
    llong negRes = -INF;
    std::vector <int> pos;
    for (int i = n - 1 ; i >= 1 ; --i)
    {
        dp[i] = -INF;
        int times = 0;
        for (const int &next : pos)
        {
            assert(next != i + 1);
            dp[i] = std::max(dp[i], dp[next] + 1LL * maxDiv[next - i] * a[next]);
        }

        dp[i] = std::max(dp[i], negRes);
        if (a[i + 1] <= 0) negRes = std::max(negRes, dp[i + 1] + a[i + 1]);
        else pos.push_back(i + 1);
    }

    return dp[1];
}
