#include "pacman.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <set>
#include <map>

typedef long long llong;
const int MAXN = 500000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
int w[MAXN];
int s[MAXN];
std::pair <int,int> st[MAXN];
int len;

llong solve(const std::vector <int> &W, const std::vector <int> &S)
{
    n = W.size();
    m = S.size();

    bool isInc = true;
    for (int i = 1 ; i <= n ; ++i)
    {
        if (w[i] != i)
        {
            isInc = false;
        }

        w[i] = W[i - 1];
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        s[i] = S[i - 1];
    }

    std::sort(s + 1, s + 1 + m);
    llong ans = 0;
    if (isInc)
    {
        for (int l = 1 ; l <= m ; ++l)
        {
            for (int r = 1 ; r <= n ; ++r)
            {
                ans += s[r] - s[l] + 1;
            }
        }

        return ans;
    }


    for (int idxL = 1 ; idxL <= m ; ++idxL)
    {
        int max = 0;
        int ptr = idxL;
        int l = s[idxL];
        len = 0;

        for (int r = l ; r <= s[m] ; ++r)
        {
            int currMAX = -1;
            while (len && w[st[len - 1].first] < w[r])
            {
                currMAX = std::max(currMAX + 1, st[len - 1].second);
                len--;
            }

            st[len++] = {r, currMAX + 1};
            max = std::max(max, st[len - 1].second + len);

            if (r == s[ptr])
            {
                ans += max;
                ptr++;
            }
        }
    }

    return ans;
}
