#include "pacman.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <set>
#include <map>

#pragma attribute ((__always_inline__)) inline
#pragma GCC optimize ("unroll_loops")

typedef long long llong;
const int MAXN = 500000 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n, m;
int w[MAXN];
int s[MAXN];
int st[2 * MAXN];
int len;

llong solve(const std::vector <int> &W, const std::vector <int> &S)
{
    n = W.size();
    m = S.size();

    for (int i = 1 ; i <= n ; ++i)
    {
        w[i] = W[i - 1];
    }

    for (int i = 1 ; i <= m ; ++i)
    {
        s[i] = n + 1 - S[i - 1];
    }

    std::sort(s + 1, s + 1 + m);
    std::reverse(w + 1, w + 1 + n);
    llong ans = 0;

    for (int idxL = 1 ; idxL <= m ; ++idxL)
    {
        int max = 0;
        int ptr = idxL;
        int l = s[idxL];
        len = 0;

        for (int r = l ; r <= s[m] ; ++r)
        {
            int currMAX = -1;
            while (len && w[st[len - 2]] < w[r])
            {
                currMAX = std::max(currMAX + 1, st[len - 1]);
                len -= 2;
            }

            st[len++] = r;
            st[len++] = currMAX + 1;
            max = std::max(max, currMAX + 1 + len / 2);

            if (r == s[ptr])
            {
                ans += max;
                ptr++;
            }
        }
    }

    return ans;
}
