#include "lis.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <set>

typedef long long llong;
const int MAXN = 200 + 10;
const llong INF = 1e18;
const int INTINF = 1e9;

int n;
std::vector <int> order;

int find_maximum(int n)
{
    order.resize(n);
    std::iota(order.begin(), order.end(), 0);

    int len = get_lis_length(order);
    while (true)
    {
        order.insert(order.begin(), order.back());
        order.pop_back();
        int curr = get_lis_length(order);
        if (curr == len - 1)
        {
            break;
        }

        len = curr;
    }

    order.push_back(order[0]);
    order.erase(order.begin());
    int to = n - 1;

    for (int i = 0 ; i < to ; ++i)
    {
        order.push_back(order[i]);
        order.erase(order.begin() + i);
        if (get_lis_length(order) > len)
        {
            len++;
            --i;
            --to;
        } else
        {
            order.insert(order.begin() + i, order.back());
            order.pop_back();
        }
    }

    return order.back();
}
