#include "pacman.h"
#include <bits/stdc++.h>

using namespace std;

const int maxn = 500005;
const int maxLog = 20;

int n;

int a[maxn];

struct SparseMAX
{
    int sparse[maxn][maxLog];
    int logValues[maxn];

    int combine(int i, int j)
    {
        if (a[i] > a[j])
        {
            return i;
        }
        else
        {
            return j;
        }
    }

    void build(int arr[])
    {
        for (int i = 1; i <= n; ++i)
        {
            sparse[i][0] = i;
        }

        for (int log = 1; (1 << log) <= n; ++log)
        {
            for (int i = 1; i + (1 << log) - 1 <= n; ++i)
            {
                sparse[i][log] = combine(sparse[i][log - 1], sparse[i + (1 << (log - 1))][log - 1]);
            }
        }

        logValues[1] = 0;

        for (int i = 2; i <= n; ++i)
        {
            logValues[i] = logValues[i - 1];

            if ((1 << (logValues[i] + 1)) < i)
            {
                ++logValues[i];
            }
        }
    }

    int query(int l, int r)
    {
        int log = logValues[r - l + 1];
        return combine(sparse[l][log], sparse[r - (1 << log) + 1][log]);
    }
};

SparseMAX sparse;

int dp[5005][5005];
bool bl[5005][5005];

int f(int from, int to)
{
    if (from > to)
    {
        return 0;
    }

    if (from == to)
    {
        return 1;
    }

    if (bl[from][to] == true)
    {
        return dp[from][to];
    }

    bl[from][to] = true;

    int pos = sparse.query(from, to);

    return dp[from][to] = 1 + max((pos - from < to - pos ? 0 : f(from, pos - 1)), (to - pos < pos - from ? 0 : f(pos + 1, to)));
}

long long solve(const vector<int> &w, const vector<int> &v)
{
    n = w.size();

    for (int i = 0; i < w.size(); ++i)
    {
        a[i + 1] = w[i];
    }

    sparse.build(a);

    long long ans = 0;

    for (int i = 0; i < v.size(); ++i)
    {
        for (int j = i; j < v.size(); ++j)
        {
            int l = min(v[i], v[j]);
            int r = max(v[i], v[j]);
            ans += f(l, r);
        }
    }

    return ans;
}
