#include "jumps.h"
#include <iostream>
#include <vector>
using namespace std;
const int MAXN=2e5+10;
const long long INF=1e15;
struct Prava {
    long long a;
    long long b;
    double x;
    friend bool operator < (Prava a, Prava b) {
        return a.x<b.x;
    }
};
int least[MAXN];
bool er[MAXN];
long long a[MAXN], dp[MAXN], maxs[MAXN];
vector <Prava> env[2][4];
/*void eratosten() {
    for (long long i=2;i<MAXN;i++) {
        if (!er[i]) {
            least[i]=i;
            for (long long j=i*i;j<MAXN;j+=i) {
                if (!er[j]) least[j]=i;
                er[j]=true;
            }
            if (i<=100) cout << i << ' ';
        }
    }
    cout << endl;
}*/
double intersect(long long a1, long long b1, long long a2, long long b2) {
    double da, db;
    da=a1-a2;
    db=b2-b1;
    if (da==0) return -INF;
    return db/da;
}
void add_prava(int type, int ind, long long a, long long b) {
    if (env[type][ind].empty()) {
        env[type][ind].push_back({a,b,INF});
        return;
    }
    long long cura, curb;
    int i;
    while (env[type][ind].size()>1) {
        i=env[type][ind].size()-1;
        cura=env[type][ind][i-1].a; curb=env[type][ind][i-1].b;
        double x=intersect(cura,curb,a,b);
        if (x<env[type][ind][i].x) break;
        env[type][ind].pop_back();
    }
    i=env[type][ind].size()-1;
    cura=env[type][ind][i].a; curb=env[type][ind][i].b;
    double x=intersect(cura,curb,a,b);
    env[type][ind].push_back({a,b,x});
}
int find_br(int type, int ind, int x) {
    if (env[type][ind].empty()) return -1;
    int l, r, mid;
    l=0; r=env[type][ind].size()-1;
    while (l<=r) {
        mid=(l+r)/2;
        if (env[type][ind][mid].x<=x) l=mid+1;
        else r=mid-1;
    }
    return l;
}
long long calc(int type, int ind, int i, long long x) {
    return env[type][ind][i].a*x+env[type][ind][i].b;
}
long long max_prize(std::vector<int> A) {
    int n=A.size();
    for (int i=1;i<=n;i++) a[i]=A[i];
    dp[0]=0;
    dp[1]=-INF;
    add_prava(0,0,0,0);
    add_prava(1,0,0,0);
    maxs[0]=maxs[1]=0;
    for (int i=2;i<n;i++) {
        int ost2=i%2, ost3=i%3;
        int i2, i3;
        i2=find_br(0,ost2,a[i]);
        i3=find_br(1,ost3,a[i]);
        if (!env[0][ost2].empty()) dp[i]=max(dp[i],calc(0,ost2,i2,a[i])+a[i]*(i/2));
        if (!env[1][ost3].empty()) dp[i]=max(dp[i],calc(1,ost3,i3,a[i])+a[i]*(i/3));
        dp[i]=max(dp[i],maxs[i-2]+a[i]);
        add_prava(0,ost2,-i/2,dp[i]);
        add_prava(1,ost3,-i/3,dp[i]);
    }
    return dp[n-1];
}
