#include <bits/stdc++.h>
#include "pacman.h"
using namespace std;

const int maxn = 5e5+2;
int n, m, a[maxn], k, k1, k2;
map <long long, int> mymap;
struct tree
{
    int maxel;
    int pos;
};
tree t[4*maxn];

void make_tree(int i, int l, int r)
{
    if (l == r)
    {
        t[i].maxel = a[r];
        t[i].pos = r;
        return;
    }

    int mid = (l + r) >> 1;
    make_tree(2*i, l, mid);
    make_tree(2*i+1, mid+1, r);

    if (t[2*i].maxel > t[2*i+1].maxel)
    {
        t[i].maxel = t[2*i].maxel;
        t[i].pos = t[2*i].pos;
    }
    else
    {
        t[i].maxel = t[2*i+1].maxel;
        t[i].pos = t[2*i+1].pos;
    }
}

tree find_max(int x, int l, int r, int&i, int&j)
{
    if (l > j || r < i) return {0,0};
    if (l >= i && r <= j)
        return t[x];

    int mid = (l + r) >> 1;
    tree t1 = find_max(2*x, l, mid, i, j);
    tree t2 = find_max(2*x+1, mid+1, r, i, j);

    if (t1.maxel > t2.maxel)
        return t1;
    return t2;
}

int rec(int i, int j)
{
    //cout << i << " " << j << endl;
    if (i > j) return 0;
    if (i == j) return 1;
    if (i == j-1) return 2;
    k = mymap[i*maxn+j];
    //cout << k << endl;
    if (k) return k;

    int pos = find_max(1, 1, n, i, j).pos;

    int k1 = rec(i, pos-1);
    int k2 = rec(pos+1, j);
    mymap[i*maxn+pos-1] = k1;
    mymap[(pos+1)*maxn+j] = k2;
    return ((k1 > k2) ? k1 : k2) + 1;
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    n = (int)(w.size());
    int i;
    for (i=1; i<=n; ++i)
        a[i] = w[i-1];

    make_tree(1, 1, n);


    long long ans = 0;
    m = (int)(S.size());
    int j, p1, p2, tek;
    for (i=0; i<m; ++i)
    {
        for (j=i; j<m; ++j)
        {
            p1 = S[i]; p2 = S[j];
            if (p1 > p2)
            {
                p1 = p1 + p2;
                p2 = p1 - p2;
                p1 = p1 - p2;
            }
            tek = (rec(p1, p2));
            mymap[p1*maxn+p2] = tek;
            ans += (long long)(tek);
            //cout << tek << endl;
        }
    }
    return ans;
}