#include "pacman.h"
#include <bits/stdc++.h>
using namespace std;

const int MAXN =  5000 + 5;
int n;
int w[MAXN];
int tree[4 * MAXN];



int maxInd[MAXN][MAXN];

void precMaxInd()
{
    for (int L = 1; L <= n; L++)
    {
        int ind = L;
        int val = w[L];
        for (int i = L; i <= n; i++)
        {
            if (w[i] > val)
            {
                val = w[i];
                ind = i;
            }
            maxInd[L][i] = ind;
        }
    }
}

void init(const std::vector<int>& _w)
{
    n = _w.size();
    for (int i = 0; i < n; i++)
        w[i+1] = _w[i];

    precMaxInd();
}

int getMaxInd(int L, int R)
{
    int ind = L;
    int val = w[L];
    for (int i = L; i <= R; i++)
    {
        if (w[i] > val)
        {
            val = w[i];
            ind = i;
        }
    }
    return ind;
}

int dp[MAXN][MAXN];
int rec(int L, int R)
{
    if (L > R) return 0;
    if (L == R) return 1;
    if (dp[L][R]) return dp[L][R];

    int ret = 0;
    int p = maxInd[L][R];

    ret = max(rec(L, p-1), rec(p+1, R));

    return dp[L][R] = ret + 1;
}

int solveLevel(int L, int R)
{
    return rec(L, R);
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    init(w);
    long long ans = 0;
    for (int i = 0; i < S.size(); i++)
    {
        for (int j = 0; j < S.size(); j++)
        {
            if (S[i] > S[j]) continue;
            long long t = solveLevel(S[i], S[j]);
            ans += t;
        }
    }
    return ans;
}
