#include<bits/stdc++.h>


using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10, block = sqrt(maxn);
const ll inf = 1e18;

int n;
ll a[maxn], dp[maxn];

struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    double calc(ll x)
    {
        return k * x + m;
    }
};

double intersect(line l1, line l2)
{
    if (l1.k == l2.k)
    {
        if (l1.m > l2.m)
            return inf;
        return -inf;
    }

    return (double)(l1.m - l2.m) / (double)(l2.k - l1.k);
}

struct convex_hull_trick
{
    vector < line > hull;

    void add_line(double k, double m)
    {
        line l(k, m);
        while(hull.size() > 1 &&
              intersect(hull[hull.size() - 2], hull.back()) >
              intersect(hull[hull.size() - 2], l))
                hull.pop_back();
        hull.push_back(l);
    }

    ll query(ll x)
    {
        if (hull.empty())
            return -inf;
        int lf = 0, rf = (int)(hull.size()) - 2;
        while(lf <= rf)
        {
            int mf = (lf + rf) / 2;
            if (intersect(hull[mf], hull[mf + 1]) < (double)(x))
                lf = mf + 1;
            else
                rf = mf - 1;
        }
        return hull[lf].calc(x);
    }

};
int low_div[maxn];
vector < ll > primes;
vector < convex_hull_trick > act[block + 10];

void precompute()
{
    for (int i = 1; i <= n; i ++)
        low_div[i] = - 1;

    for (int i = 2; i <= n; i ++)
    {
        if (low_div[i] != -1)
            continue;
        if (i <= block)
        {
            act[i].resize(i);
            primes.push_back(i);
        }
        for (int j = i * 2; j <= n; j += i)
            if (low_div[j] == -1)
                low_div[j] = i;
    }
    /**for (ll cur : primes)
    {
        cout << cur << endl;
    }*/
}

ll calc_dp()
{
    dp[0] = -inf;
    dp[1] = 0;
    ll mx = -inf;
    for (int i = 2; i <= n; i ++)
    {
        mx = max(mx, dp[i - 2]);

        for (int cur : primes)
        {
            act[cur][(i - 1) % cur].add_line(i - 1, dp[i - 1] * (ll)(cur));

        }
        dp[i] = mx + a[i];
        for (int jump : primes)
        {
            double d1 = act[jump][i % jump].query(-a[i]);
            ll cur = (d1 + a[i] * (ll)(i)) / (ll)jump;
            dp[i] = max(dp[i], cur);
            /**for (int pos : act[jump][i % jump])
            {
                ///cout << i << " : " << jump << " : " << pos << endl;
                dp[i] = max(dp[i], dp[pos] + (ll)((i - pos) / jump) * a[i]);
            }*/
            /**for (int t = 1; jump * t < i; t ++)
            {
                dp[i] = max(dp[i], dp[i - jump * t] + (ll)(t) * a[i]);
                if (a[i - jump * t] > a[i])
                    break;
            }*/
        }
        ///cout << dp[i] << " ";
    }
    ///cout << endl;

    return dp[n];
}

ll max_prize(vector < int > vec)
{
    n = vec.size();
    for (int i = 0; i < n; i ++)
        a[i + 1] = vec[i];
    precompute();
    return calc_dp();
}

