#include<bits/stdc++.h>

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e5 + 10;

int n, m;
int w[maxn];
int s[maxn];
int lc[maxn], rc[maxn], root;
int left_bor[maxn], right_bor[maxn];
void cartesian()
{
    for (int i = 1; i <= n; i ++)
    {
        lc[i] = rc[i] = -1;
        left_bor[i] = 1;
        right_bor[i] = n;
    }
    stack < int > st;
    for (int i = 1; i <= n; i ++)
    {
        while(!st.empty() && w[st.top()] < w[i])
        {
            lc[i] = st.top();
            st.pop();
        }
        if (!st.empty())
            left_bor[i] = st.top() + 1;
        st.push(i);
    }

    while(!st.empty())
    {
        st.pop();
    }

    for (int i = n; i > 0; i --)
    {
        while(!st.empty() && w[st.top()] < w[i])
        {
            rc[i] = st.top();
            st.pop();
        }
        if (!st.empty())
            right_bor[i] = st.top() - 1;

        st.push(i);
    }
}

int pref[maxn];


int max_depth[maxn];

///int left_value[maxn], right_value[maxn];

struct node
{
    int mx;
    ll sum;
    int cnt;

    node(int _mx = 0, ll _sum = 0, int _cnt = 0)
    {
        mx = _mx;
        sum = _sum;
    }
};

node merge_node(node lf, node rf)
{
    node mf;
    mf.mx = max(lf.mx, rf.mx);
    mf.sum = lf.sum + rf.sum;
    mf.cnt = lf.cnt + rf.cnt;
    return mf;
}

void merge_lazy(pair < ll, ll > &l1, pair < ll, ll > &l2)
{
    if (l2.second != 0)
        l1 = l2;
    else
    {
        l1.first += l2.first;
    }
}

struct segment_tree
{
    node tree[4 * maxn];
    pair < ll, ll > lazy[4 * maxn];

    void build_tree(int root, int left, int right)
    {
        if (left == right)
        {
            if (pref[left])
                tree[root].cnt = 1;
            return;
        }

        int mid = (left + right) / 2;
        build_tree(root * 2, left, mid);
        build_tree(root * 2 + 1, mid + 1, right);

        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    }

    void push_lazy(int root, int left, int right)
    {
        if (lazy[root].first == 0 && lazy[root].second == 0)
            return;
        if (lazy[root].second != 0)
        {
            tree[root].mx = lazy[root].second;
            tree[root].sum = (ll)tree[root].cnt * lazy[root].second;
        }
        ///cout << "push lazy " << root << " " << left << " " << right << " " << lazy[root].first << " " << lazy[root].second << endl;
        tree[root].mx += lazy[root].first;
        tree[root].sum += lazy[root].first * (ll)tree[root].cnt;
        if (left != right)
        {
            merge_lazy(lazy[root * 2], lazy[root]);
            merge_lazy(lazy[root * 2 + 1], lazy[root]);
        }

        lazy[root].first = lazy[root].second = 0;
    }

    void point_update(int root, int left, int right, int pos, int val)
    {
        push_lazy(root, left, right);

        if (left == right)
        {
            tree[root].mx = val;
            tree[root].sum = val;
            return;
        }

        int mid = (left + right) / 2;
        if (pos <= mid)
            point_update(root * 2, left, mid, pos, val);
        else
            point_update(root * 2 + 1, mid + 1, right, pos, val);

        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    }

    void range_update(int root, int left, int right, int qleft, int qright, pair < ll, ll > val)
    {
        push_lazy(root, left, right);

        if (left > qright || right < qleft)
            return;

        if (left >= qleft && right <= qright)
        {
            lazy[root] = val;
            push_lazy(root, left, right);
            return;
        }

        int mid = (left + right) / 2;
        range_update(root * 2, left, mid, qleft, qright, val);
        range_update(root * 2 + 1, mid + 1, right, qleft, qright, val);

        tree[root] = merge_node(tree[root * 2], tree[root * 2 + 1]);
    }

    ll sum_query(int root, int left, int right, int qleft, int qright)
    {
        push_lazy(root, left, right);
        if (left > qright || right < qleft)
            return 0;

        if (left >= qleft && right <= qright)
            return tree[root].sum;

        int mid = (left + right) / 2;
        return sum_query(root * 2, left, mid, qleft, qright) +
                sum_query(root * 2 + 1, mid + 1, right, qleft, qright);
    }

    int query_point(int root, int left, int right, int pos)
    {
        push_lazy(root, left, right);
        if (left == right)
            return tree[root].mx;

        int mid = (left + right) / 2;
        if (pos <= mid)
            return query_point(root * 2, left, mid, pos);

        return query_point(root * 2 + 1, mid + 1, right, pos);
    }

    int walk_left(int root, int left, int right, int qleft, int qright, int val)
    {
        push_lazy(root, left, right);
        if (left > qright || right < qleft || tree[root].mx <= val)
            return qright + 1;

        if (left == right)
            return left;

        int mid = (left + right) / 2;
        if (left >= qleft && right <= qright)
        {
            push_lazy(root * 2, left, mid);
            push_lazy(root * 2 + 1, mid + 1, right);

            if (tree[root * 2].mx > val)
                return walk_left(root * 2, left, mid, qleft, qright, val);
            return walk_left(root * 2 + 1, mid + 1, right, qleft, qright, val);
        }

        return min(walk_left(root * 2, left, mid, qleft, qright, val),
                   walk_left(root * 2 + 1, mid + 1, right, qleft, qright, val));
    }

    int walk_right(int root, int left, int right, int qleft, int qright, int val)
    {
        push_lazy(root, left, right);
        if (left > qright || right < qleft || tree[root].mx <= val)
            return qleft - 1;

        if (left == right)
            return left;

        int mid = (left + right) / 2;
        if (left >= qleft && right <= qright)
        {
            push_lazy(root * 2, left, mid);
            push_lazy(root * 2 + 1, mid + 1, right);

            if (tree[root * 2 + 1].mx > val)
                return walk_right(root * 2 + 1, mid + 1, right, qleft, qright, val);
            return walk_right(root * 2, left, mid, qleft, qright, val);
        }

        return max(walk_right(root * 2, left, mid, qleft, qright, val),
                   walk_right(root * 2 + 1, mid + 1, right, qleft, qright, val));
    }
};

segment_tree left_values, right_values;

int lb[maxn], rb[maxn];
vector < int > sp;
int rev[maxn];
ll dfs(int v)
{
    ll ans = 0;
    max_depth[v] = 1;
    int ld = 0, rd = 0;
    if (lc[v] != -1)
    {
        ans += dfs(lc[v]);
        ld = max_depth[lc[v]];

        right_values.range_update(1, 1, n, left_bor[lc[v]], right_bor[lc[v]], {1, 0});
        if (rev[v] != 0)
        {
            ll val = right_values.sum_query(1, 1, n, left_bor[lc[v]], right_bor[lc[v]]);
            ans = ans + val;
            //cout << "node " << v  << " " << val << " " << left_bor[lc[v]] << " " << right_bor[lc[endl;
        }
        /**for (int cur : act[lc[v]])
        {

            right_value[cur] ++;
            if (act[v].size() > 0)
                ans = ans + right_value[cur];
        }*/
        max_depth[v] = max(max_depth[v], max_depth[lc[v]] + 1);
    }
    if (rc[v] != -1)
    {
        ans += dfs(rc[v]);
        rd = max_depth[rc[v]];
        left_values.range_update(1, 1, n, left_bor[rc[v]], right_bor[rc[v]], {1, 0});
        if (rev[v] != 0)
            ans = ans + left_values.sum_query(1, 1, n, left_bor[rc[v]], right_bor[rc[v]]);
        /**for (int i = 0; i < (int)act[rc[v]].size(); i ++)
        {
            left_value[act[rc[v]][i]] ++;
            if (act[v].size() > 0)
                ans = ans + left_value[act[rc[v]][i]];
        }*/

        max_depth[v] = max(max_depth[v], max_depth[rc[v]] + 1);
    }
    ///cout << "here " << v << " " << ans << endl;
    if (lc[v] != -1 && rc[v] != -1)
    {

        if (rb[lc[v]] - lb[lc[v]] + 1 < rb[rc[v]] - lb[rc[v]] + 1)
        {
            for (int i = lb[lc[v]]; i <= rb[lc[v]]; i ++)
            {
                int l = sp[i];
                ll val = right_values.query_point(1, 1, n, l);
                int to = left_values.walk_left(1, 1, n, left_bor[rc[v]], right_bor[rc[v]], val);
                ll bef = pref[to - 1] - pref[v];
                ans = ans + bef * val + left_values.sum_query(1, 1, n, to, right_bor[rc[v]]);

            }
        }
        else
        {
            for (int i = lb[rc[v]]; i <= rb[rc[v]]; i ++)
            {
                int r = sp[i];
                ll val = left_values.query_point(1, 1, n, r);
                int to = right_values.walk_right(1, 1, n, left_bor[lc[v]], right_bor[lc[v]], val);
                ll bef = pref[v - 1] - pref[to];
                ans = ans + bef * val + right_values.sum_query(1, 1, n, left_bor[lc[v]], to);
            }
        }

    }


    lb[v] = n + 1;
    rb[v] = 0;
    if (rev[v] != 0)
    {
        ans ++;
        int lv = 1, rv = 1;

        lb[v] = rb[v] = rev[v];

        if (lc[v] != -1)
            lv = max_depth[lc[v]] + 1;
        if (rc[v] != -1)
            rv = max_depth[rc[v]] + 1;
        //cout << "wtf " << v << " " << lv << " " << rv << endl;
        left_values.point_update(1, 1, n, v, lv);
        right_values.point_update(1, 1, n, v, rv);
        //cout << "here " << right_values.query_point(1, 1, n, v) << endl;


    }



    if (lc[v] != -1)
    {
        int to = right_values.walk_right(1, 1, n, left_bor[lc[v]], right_bor[lc[v]], rd + 1);
        right_values.range_update(1, 1, n, to + 1, right_bor[lc[v]], {0, rd + 1});
        /**for (int cur : act[lc[v]])
        {
            right_value[cur] = max(right_value[cur], rd + 1);
        }*/
        lb[v] = min(lb[v], lb[lc[v]]);
    }
    if (rc[v] != -1)
    {
        int to = left_values.walk_left(1, 1, n, left_bor[rc[v]], right_bor[rc[v]], ld + 1);
        left_values.range_update(1, 1, n, left_bor[rc[v]], to - 1, {0, ld + 1});
        /**for (int cur : act[rc[v]])
        {
            left_value[cur] = max(left_value[cur], ld + 1);
        }*/
        rb[v] = max(rb[v], rb[rc[v]]);
    }
    //cout << "vertex " << v << " " << lb[v] << " " << rb[v] << endl;

    //cout << "ans " << ans << endl;
    return ans;
}

ll solve(const vector < int > &values, const vector < int > &my_set)
{
    n = values.size();
    m = my_set.size();

    for (int i = 1; i <= n; i ++)
    {
        w[i] = values[i - 1];
    }
    for (int i = 1; i <= m; i ++)
    {
        s[i] = my_set[i - 1];
        pref[s[i]] = 1;
    }
    left_values.build_tree(1, 1, n);
    right_values.build_tree(1, 1, n);
    for (int i = 1; i <= n; i ++)
    {
        pref[i] = pref[i - 1] + pref[i];
    }
    sort(s + 1, s + m + 1);
    sp.push_back(0);
    for (int i = 1; i <= m; i ++)
    {
        rev[s[i]] = i;
        sp.push_back(s[i]);
    }

    cartesian();
    root = 1;
    while(w[root] != n)
        root ++;

    ll ans = dfs(root);

    return ans;


}

