#include "pacman.h"
#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll BUCKET_SIZE=300;
const ll MAXN=5e5+6;
const ll INF=2e6;
const ll NUM_BUCKETS=MAXN/BUCKET_SIZE+10;
ll alo[MAXN];
struct segment_tree
{
    pair<ll,ll> tr[MAXN];
    void build(ll l,ll r,ll idx)
    {
        tr[idx]={0,0};
        if(l!=r)
        {
            ll mid=(l+r)/2;
            build(l,mid,idx*2);
            build(mid+1,r,idx*2+1);
        }
    }
    void update(ll l,ll r,ll idx,ll pos,ll val)
    {
        if(l>r)return;
        if(l>pos)return;
        if(r<pos)return;
        if(l==r)
        {
            tr[idx]={val,l};
            return;
        }
        ll mid=(l+r)/2;
        if(pos<=mid)update(l,mid,idx*2,pos,val);
        else update(mid+1,r,idx*2+1,pos,val);
        tr[idx]=max(tr[idx*2],tr[idx*2+1]);
    }
    pair<ll,ll> query(ll l,ll r,ll idx,ll ql,ll qr)
    {
        if(l>r)return {-1,0};
        if(l>=ql&&r<=qr)return tr[idx];
        ll mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tree,tree1,euler_tree;
ll n;
ll a[MAXN];
ll endp[MAXN];
ll par[MAXN];
vector<ll>g[MAXN];
void make_alo(ll l,ll r,ll h,ll prv)
{
    //cout<<l<<" "<<r<<endl;
    if(l==r)
    {
        alo[l]=h;
        par[l]=prv;
        g[prv].push_back(l);
        return;
    }
    if(l>r)return;
    pair<ll,ll> peak=tree.query(1,n,1,l,r);
    //cout<<peak.second<<endl;
    alo[peak.second]=h;
    par[peak.second]=prv;
    g[prv].push_back(peak.second);
    make_alo(l, peak.second-1,h+1, peak.second);
    make_alo(peak.second+1, r, h+1, peak.second);
}
ll time_in[MAXN],time_out[MAXN];
ll t=0;
void dfs(ll u)
{
    time_in[u]=++t;
    for(auto xd:g[u])
    {
        dfs(xd);
    }
    time_out[u]=t;
}
struct euler_tree
{
    ll tr[MAXN];
    ll lazy[MAXN];
    void init()
    {
        for(ll i=0;i<MAXN;i++)tr[i]=-INF;
        memset(lazy,0,sizeof(lazy));
    }
    void push(ll l,ll r,ll idx)
    {
        tr[idx]+=lazy[idx];
        if(l!=r)
        {
            lazy[idx*2]+=lazy[idx];
            lazy[idx*2+1]+=lazy[idx];
        }
        lazy[idx]=0;
    }
    void update(ll l,ll r,ll idx,ll ql,ll qr,ll val)
    {
        push(l,r,idx);
        if(l>qr)return;
        if(r<ql)return;
        if(l>=ql&&r<=qr)
        {
            lazy[idx]+=val;
            push(l,r,idx);
            return;
        }
        ll mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,val);
        update(mid+1,r,idx*2+1,ql,qr,val);
        tr[idx]=max(tr[idx*2],tr[idx*2+1]);
    }
    ll query(ll l,ll r,ll idx,ll ql,ll qr)
    {
        push(l,r,idx);
        if(l>qr||r<ql)return 0;
        if(l>=ql&&r<=qr)return tr[idx];
        ll mid=(l+r)/2;
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}et;
vector<ll>in_bucket[NUM_BUCKETS];
void add(ll pos,ll coef)
{
    //cout<<" add "<<pos<<" "<<coef<<endl;
    //cout<<time_in[pos]<<" "<<time_out[pos]<<endl;
    et.update(1,n,1,time_in[pos],time_out[pos],coef);
    et.update(1,n,1,time_in[pos],time_in[pos],coef*INF);
}
long long solve(const vector<int >& w, const vector<int >& S)
{
    n=w.size();
    for(ll i=0;i<w.size();i++)a[i+1]=w[i];
    for(ll i=0;i<S.size();i++)endp[S[i]]=1;
    tree.build(1,n,1);
    for(ll i=1;i<=n;i++)tree.update(1,n,1,i,a[i]);
    make_alo(1,n,1,0);
    tree1.build(1,n,1);
    for(ll i=1;i<=n;i++)tree1.update(1,n,1,i,alo[i]);
    ll highest_peak=1;
    for(ll i=2;i<=n;i++)
    {
        if(alo[i]<alo[highest_peak])highest_peak=i;
    }
    dfs(highest_peak);
    for(ll i=0;i<S.size();++i)
    {
        ll b_id=S[i]/BUCKET_SIZE;
        in_bucket[b_id].push_back(S[i]);
    }
    long long ans=0;
    for(ll i=0;i<NUM_BUCKETS;++i)
    {
        if(in_bucket[i].size()==0)break;
        et.init();
        sort(in_bucket[i].begin(),in_bucket[i].end());
        ll curl=in_bucket[i][0]+1;
        ll curr=curl-1;
        for(ll j=in_bucket[i][0];j<=n;++j)
        {
            while(curr<j)
            {
                curr++;
                add(curr,+1);
            }
            if(endp[j])
            {
                for(ll l=0;l<in_bucket[i].size();++l)
                {
                    if(in_bucket[i][l]>curr)break;
                    while(curl>in_bucket[i][l])
                    {
                        --curl;
                        add(curl,+1);
                    }
                    while(curl<in_bucket[i][l])
                    {
                        add(curl,-1);
                        ++curl;
                    }
                    //cout<<"# "<<curl<<" "<<curr<<" "<<et.tr[1]<<endl;
                    ans+=(long long)(max(0ll,et.tr[1]));
                }
            }
        }
    }
    return ans;
}
