#include "pacman.h"
#include<bits/stdc++.h>
using namespace std;
const int BUCKET_SIZE=77;
const int MAXN=5e5+6;
const int INF=2e7;
const int NUM_BUCKETS=MAXN/BUCKET_SIZE+10;
int alo[MAXN];
struct segment_tree
{
    pair<int,int> tr[MAXN];
    void build(int l,int r,int idx)
    {
        tr[idx]={0,0};
        if(l!=r)
        {
            int mid=(l+r)/2;
            build(l,mid,idx*2);
            build(mid+1,r,idx*2+1);
        }
    }
    void update(int l,int r,int idx,int pos,int val)
    {
        if(l>r)return;
        if(l>pos)return;
        if(r<pos)return;
        if(l==r)
        {
            tr[idx]={val,l};
            return;
        }
        int mid=(l+r)/2;
        if(pos<=mid)update(l,mid,idx*2,pos,val);
        else update(mid+1,r,idx*2+1,pos,val);
        tr[idx]=max(tr[idx*2],tr[idx*2+1]);
    }
    pair<int,int> query(int l,int r,int idx,int ql,int qr)
    {
        if(l>r)return {-1,0};
        if(l>=ql&&r<=qr)return tr[idx];
        int mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}tree,tree1;
int n;
int a[MAXN];
int endp[MAXN];
int par[MAXN];
vector<int>g[MAXN];
void make_alo(int l,int r,int h,int prv)
{
    //cout<<l<<" "<<r<<endl;
    if(l==r)
    {
        alo[l]=h;
        par[l]=prv;
        g[prv].push_back(l);
        return;
    }
    if(l>r)return;
    pair<int,int> peak=tree.query(1,n,1,l,r);
    //cout<<peak.second<<endl;
    alo[peak.second]=h;
    par[peak.second]=prv;
    g[prv].push_back(peak.second);
    make_alo(l, peak.second-1,h+1, peak.second);
    make_alo(peak.second+1, r, h+1, peak.second);
}
int time_in[MAXN],time_out[MAXN];
int t=0;
void dfs(int u)
{
    time_in[u]=++t;
    for(auto xd:g[u])
    {
        dfs(xd);
    }
    time_out[u]=t;
}
struct euler_tree
{
    int tr[MAXN];
    int lazy[MAXN];
    void init()
    {
        for(int i=0;i<MAXN;i++)tr[i]=-INF;
        memset(lazy,0,sizeof(lazy));
    }
    void push(int l,int r,int idx)
    {
        tr[idx]+=lazy[idx];
        if(l!=r)
        {
            lazy[idx*2]+=lazy[idx];
            lazy[idx*2+1]+=lazy[idx];
        }
        lazy[idx]=0;
    }
    void update(int l,int r,int idx,int ql,int qr,int val)
    {
        push(l,r,idx);
        if(l>qr)return;
        if(r<ql)return;
        if(l>=ql&&r<=qr)
        {
            lazy[idx]+=val;
            push(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,val);
        update(mid+1,r,idx*2+1,ql,qr,val);
        tr[idx]=max(tr[idx*2],tr[idx*2+1]);
    }
    int query(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(l>qr||r<ql)return 0;
        if(l>=ql&&r<=qr)return tr[idx];
        int mid=(l+r)/2;
        return max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}et;
vector<int>in_bucket[NUM_BUCKETS];
void add(int pos,int coef)
{
    //cout<<" add "<<pos<<" "<<coef<<endl;
    //cout<<time_in[pos]<<" "<<time_out[pos]<<endl;
    et.update(1,n,1,time_in[pos],time_out[pos],coef);
    et.update(1,n,1,time_in[pos],time_in[pos],coef*INF);
}
long long solve(const vector<int>& w, const vector<int>& S)
{
    n=w.size();
    for(int i=0;i<w.size();i++)a[i+1]=w[i];
    for(int i=0;i<S.size();i++)endp[S[i]]=1;
    tree.build(1,n,1);
    for(int i=1;i<=n;i++)tree.update(1,n,1,i,a[i]);
    make_alo(1,n,1,0);
    tree1.build(1,n,1);
    for(int i=1;i<=n;i++)tree1.update(1,n,1,i,alo[i]);
    int highest_peak=1;
    for(int i=2;i<=n;i++)
    {
        if(alo[i]<alo[highest_peak])highest_peak=i;
    }
    dfs(highest_peak);
    for(int i=0;i<S.size();++i)
    {
        int b_id=S[i]/BUCKET_SIZE;
        in_bucket[b_id].push_back(S[i]);
    }
    long long ans=0;
    for(int i=0;i<NUM_BUCKETS;++i)
    {
        if(in_bucket[i].size()==0)continue;
        et.init();
        sort(in_bucket[i].begin(),in_bucket[i].end());
        int curl=in_bucket[i][0]+1;
        int curr=curl-1;
        for(int j=in_bucket[i][0];j<=n;++j)
        {
            while(curr<j)
            {
                curr++;
                add(curr,+1);
            }
            if(endp[j])
            {
                for(int l=0;l<in_bucket[i].size();++l)
                {
                    if(in_bucket[i][l]>curr)break;
                    while(curl>in_bucket[i][l])
                    {
                        --curl;
                        add(curl,+1);
                    }
                    while(curl<in_bucket[i][l])
                    {
                        add(curl,-1);
                        ++curl;
                    }
                    //cout<<"# "<<curl<<" "<<curr<<" "<<et.tr[1]<<endl;
                    ans+=(long long)(max(0,et.tr[1]));
                }
            }
        }
    }
    return ans;
}
