#include "jumps.h"
#include<bits/stdc++.h>
#define fi first
#define se second

using namespace std;

const int MAXN=2e5+5;
const int MAXR=20000;
const int INF=2e9;

typedef pair<long long,long long> ln;

struct CHT
{
    vector<pair<ln,long long> > lines;

    int intersect(ln a,ln b)
    {
        // if(a.fi==b.fi) ...
        return (b.se-a.se)/(a.fi-b.fi);
    }

    void add(ln t)
    {
        if(lines.empty())
        {
            lines.push_back({t,INF});
            return;
        }
        if(t.se<=lines.back().fi.se) return;
        while(!lines.empty())
        {
            if(t.fi*lines.back().se+t.se >= lines.back().fi.fi*lines.back().se+lines.back().fi.se) lines.pop_back();
            else break;
        }

        if(!lines.empty()) lines.push_back({t, intersect(t,lines.back().fi)});
        else lines.push_back({t, INF});
    }

    long long query(int x,int curk)
    {
        if(lines.empty()) return x;
        int l=0,r=lines.size()-1;
        while(l<r)
        {
            int mid=(l+r)/2;
            if(lines[mid].se<x) l=mid+1;
            else r=mid;
        }
        return (long long)x*(lines[l].fi.fi-curk)+lines[l].fi.se;
    }
};

int n;
long long dp[MAXN];
long long pref[MAXN];
int lp[MAXN];
long long c[MAXN];
vector<int> pr;
int MAXP=2000;
CHT f[2000][MAXR];

void precomp()
{
    lp[1]=1;
    for(int i=2;i<=n;i++)
    {
        if(!lp[i])
        {
            pr.push_back(i);
            lp[i]=i;
            if((long long)i*i>n) continue;
            for(int j=i*i;j<=n;j+=i)
            {
                if(!lp[j]) lp[j]=i;
            }
        }
    }
    for(int i=1;i<=n;i++) c[i]=i/lp[i];
}

long long max_prize(std::vector<int> a)
{
    n=a.size();

    precomp();
    MAXP=min(MAXP, (int)pr.size());

    dp[0]=dp[1]=0;
    pref[0]=pref[1]=0;
    for(int i=0;i<MAXP;i++)
    {
        f[i][0].add({(n-1-0)/pr[i], (long long)0});
    }
    for(int i=2; i<n; i++)
    {
        dp[i]=a[i];
        if(a[i]>0)
        {
            for(int j=0;j<MAXP;j++)
            {
                int r=i%pr[j];
                int curk=(n-1-i)/pr[j];
                dp[i]=max(dp[i], f[j][r].query(a[i], curk));
            }
            for(int j=MAXP;j<pr.size();j++)
            {
                int tmp=1;
                for(int t=i-pr[j];t>=0;t-=pr[j])
                {
                    if(t==1) break;
                    dp[i]=max(dp[i], dp[t]+tmp*a[i]); //
                    tmp++;
                }
            }
        }
        else dp[i]=max(dp[i], pref[i-2]+a[i]);

        for(int j=0;j<MAXP;j++)
        {
            f[j][i%pr[j]].add({(n-1-i)/pr[j], dp[i]});
        }

        pref[i]=max(pref[i-1], dp[i]);
    }

    return dp[n-1];
}
