#include <bits/stdc++.h>
#include "pacman.h"
using namespace std;
typedef long long ll;

const ll Size=5e3+1;
vector<ll> arr;
pair<ll,ll> seg_tree[Size];
ll n,m;

void build(ll i,ll l,ll r){
    if(l==r){
        seg_tree[i]={arr[l],l};
    }else{
        ll mid=(l+r)/2;
        build(i*2,l,mid);
        build(i*2+1,mid+1,r);
        seg_tree[i]=max(seg_tree[i*2],seg_tree[i*2+1]);
    }
}

pair<ll,ll> query(ll i,ll l,ll r,ll tl,ll tr){
    if(tl>r or tr<l)
        return {-1,-1};
    if(tl==l and tr==r){
        return seg_tree[i];
    }else{
        ll mid=(l+r)/2;
        pair<ll,ll> left_ans=query(i*2,l,mid,tl,min(mid,tr));
        pair<ll,ll> right_ans=query(i*2+1,mid+1,r,max(mid+1,tl),tr);
        if(left_ans.first==-1)
            return right_ans;
        if(right_ans.first==-1)
            return left_ans;
        return max(left_ans,right_ans);
    }
}

ll b_search(ll l,ll r){
    if(l>r)
        return 0;
    if(l==r){
        return 1;
    }else{
        pair<ll,ll> maximum=query(1,0,n-1,l,r);
        ll left_max=b_search(l,maximum.second-1);
        ll right_max=b_search(maximum.second+1,r);
        return max(left_max,right_max)+1;
    }
}

long long solve(const std::vector<int>& w, const std::vector<int>& S){
    n=w.size();
    m=S.size();
    vector<ll> goodS;
    for(auto itrv:S){
        goodS.push_back(itrv);
    }
    sort(goodS.begin(),goodS.end());
    vector<pair<ll,ll>> intervals;
    for(ll i=0;i<m;i++){
        for(ll j=i;j<m;j++){
            intervals.push_back({goodS[i]-1,goodS[j]-1});
        }
    }
    for(auto itrv:w){
        arr.push_back(itrv);
    }
    build(1,0,n-1);
    ll ans=0;
    for(auto itrv:intervals){
        ll curr_ans=b_search(itrv.first,itrv.second);
        ans+=curr_ans;
    }
    return ans;
}
