#include "pacman.h"

int findBiggest(std::vector<int> w, int from, int to)
{
    int biggest = w[from], biggestPos = from;
    for(int i = from; i <= to; i++)
    {
        if(w[i] > biggest)
        {
            biggest = w[i];
            biggestPos = i;
        }
    }
    return biggestPos;
}

long long levelScore(std::vector<int> w, int from, int to)
{
    long long levelRes = 0;
    if(from == to)
    {
        return 1;
    }
    while(from != to)
    {
        int curr = findBiggest(w, from, to);
        levelRes++;
        if(curr - 1 - from + 1 >= to - (curr + 1) + 1)
        {
            to = curr - 1;
        }
        else
        {
            from = curr + 1;
        }
        if(from == to)
        {
            levelRes++;
            break;
        }
    }
    return levelRes;
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    long long res = 0;
    int sizeS = S.size();
    for(int i = 0; i < sizeS; i++)
    {
        for(int j = i; j < sizeS; j++)
        {
            //std::cout << S[i] << "->" << S[j] << std::endl;
            res += levelScore(w, S[i] - 1, S[j] - 1);
        }
    }
    return res;
}
