#include "pacman.h"
#include <bits/stdc++.h>

const int MAX_N = 500000;
std::pair<int, int> tree[4 * MAX_N];
std::vector<int> w1;
int w1Size;

void build_tree(int from, int to, int pos)
{
    if(from == to)
    {
        tree[pos].first = w1[from];
        tree[pos].second = from;
        return;
    }
    int mid = (from + to) / 2;
    build_tree(from, mid, 2 * pos);
    build_tree(mid + 1, to, 2 * pos + 1);

    if(tree[2 * pos].first > tree[2 * pos + 1].first)
    {
        tree[pos].first = tree[2 * pos].first;
        tree[pos].second = tree[2 * pos].second;
    }
    else
    {
        tree[pos].first = tree[2 * pos + 1].first;
        tree[pos].second = tree[2 * pos + 1].second;
    }
}

std::pair<int, int> findMax(int from, int to, int pos, int first, int last)
{
    if(from >= first && to <= last)
    {
        return tree[pos];
    }
    if(first > to || last < from)
    {
        return {-1, -1};
    }
    int mid = (from + to) / 2;
    std::pair<int, int> left = findMax(from, mid, 2 * pos, first, last);
    std::pair<int, int> right = findMax(mid + 1, to, 2 * pos + 1, first, last);
    if(left.first > right.first)
    {
        return left;
    }
    else
    {
        return right;
    }
}



int findBiggest(/*std::vector<int> w*/ int from, int to)
{
    int biggest = w1[from], biggestPos = from;
    for(int i = from; i <= to; i++)
    {
        if(w1[i] > biggest)
        {
            biggest = w1[i];
            biggestPos = i;
        }
    }
    return biggestPos;
}

long long levelScore(/*std::vector<int> w,*/ int from, int to)
{
    if(from > to)
    {
        return 0;
    }
    if(from == to)
    {
        return 1;
    }
    int curr = findMax(0, w1Size - 1, 1, from, to).second;
    return 1 + std::max(levelScore(from, curr - 1), levelScore(curr + 1, to));
    /*while(from != to)
    {
        int curr = findMax(0, w1Size - 1, 1, from, to).second;
        levelRes++;
        int rightFrom = curr + 1;
        int leftTo = curr - 1;
        if(rightFrom > to)
        {
            to = curr - 1;
        }
        else if(leftTo < from)
        {
            from = curr + 1;
        }
        else
        {
            int rightMax = findMax(0, w1Size - 1, 1, rightFrom, to).second;
            int leftMax = findMax(0, w1Size - 1, 1, from, leftTo).second;
                //std::cout << "tuk";

            if(std::max(to - rightMax, rightMax - rightFrom) > std::max(leftTo - leftMax, leftMax - from))
            {
                from = curr + 1;
            }
            else
            {
                to = curr - 1;
            }
        }
        /*if(curr - 1 - from + 1 >= to - (curr + 1) + 1)
        {
            to = curr - 1;
        }
        else
        {
            from = curr + 1;
        }*/
        /*if(from == to)
        {
            levelRes++;
            break;
        }*/
    //}
//    return levelRes;
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    std::vector<int> s1 = S;
    std::sort(s1.begin(), s1.end());
    w1 = w;
    w1Size = w1.size();
    build_tree(0, w1Size - 1, 1);
    long long res = 0;
    int sizeS = s1.size();
    for(int i = 0; i < sizeS; i++)
    {
        for(int j = i; j < sizeS; j++)
        {
            //std::cout << S[i] << "->" << S[j] << " " << levelScore(S[i] - 1, S[j] - 1) << std::endl;
            res += levelScore(s1[i] - 1, s1[j] - 1);
        }
    }
    return res;
}
