#include "pacman.h"
#include <bits/stdc++.h>

const int MAX_N = 500000;
std::pair<int, int> tree[4 * MAX_N];
std::vector<int> w1;
int w1Size;
int sizeS;

/**
11 4
6 8 3 5 11 7 10 9 1 4 2
1 11 3 8

*/

int ans[5007][5007];
std::pair<int, int> biggestAns[5007][5007];

void build_tree(int from, int to, int pos)
{
    if(from == to)
    {
        tree[pos].first = w1[from];
        tree[pos].second = from;
        biggestAns[from][to].first = tree[pos].first;
        biggestAns[from][to].second = tree[pos].second;
        return;
    }
    int mid = (from + to) / 2;
    build_tree(from, mid, 2 * pos);
    build_tree(mid + 1, to, 2 * pos + 1);

    if(tree[2 * pos].first > tree[2 * pos + 1].first)
    {
        tree[pos].first = tree[2 * pos].first;
        tree[pos].second = tree[2 * pos].second;
    }
    else
    {
        tree[pos].first = tree[2 * pos + 1].first;
        tree[pos].second = tree[2 * pos + 1].second;
    }
    biggestAns[from][to] = tree[pos];
}

std::pair<int, int> findMax(int from, int to, int pos, int first, int last)
{
    if(from >= first && to <= last)
    {
        return tree[pos];
    }
    if(first > to || last < from)
    {
        return {-1, -1};
    }
    int mid = (from + to) / 2;
    std::pair<int, int> left;
    if(biggestAns[first][std::min(mid, last)].first == -1 && biggestAns[first][std::min(mid, last)].second == -1)
    {
        biggestAns[first][std::min(mid, last)] = findMax(from, mid, 2 * pos, first, last);
    }
    left = biggestAns[first][std::min(mid, last)];
    std::pair<int, int> right;
    if(biggestAns[std::max(mid + 1, first)][last].first == -1 && biggestAns[std::max(mid + 1, first)][last].second == -1)
    {
        biggestAns[std::max(mid + 1, first)][last] = findMax(mid + 1, to, 2 * pos + 1, first, last);
    }
    right = biggestAns[std::max(mid + 1, first)][last];
    if(left.first > right.first)
    {
        return left;
    }
    else
    {
        return right;
    }
}



int findBiggest(/*std::vector<int> w*/ int from, int to)
{
    int biggest = w1[from], biggestPos = from;
    for(int i = from; i <= to; i++)
    {
        if(w1[i] > biggest)
        {
            biggest = w1[i];
            biggestPos = i;
        }
    }
    return biggestPos;
}

long long levelScore(/*std::vector<int> w,*/ int from, int to)
{
    if(from > to)
    {
        return 0;
    }
    if(from == to)
    {
        return 1;
    }
    int curr = findMax(0, w1Size - 1, 1, from, to).second;
    if(sizeS <= 10)
    {
        return 1 + std::max(levelScore(from, curr - 1), levelScore(curr + 1, to));
    }
    int leftScore = 0;
    if(curr - 1 < from)
    {
        leftScore = 0;
    }
    else
    {
        if(ans[from][curr - 1] == -1)
        {
            ans[from][curr - 1] = levelScore(from, curr - 1);
        }
        leftScore = ans[from][curr - 1];
    }

    int rightScore = 0;
    if(curr + 1 > to)
    {
        rightScore = 0;
    }
    else
    {
        if(ans[curr + 1][to] == -1)
        {
            ans[curr + 1][to] = levelScore(curr + 1, to);
        }
        rightScore = ans[curr + 1][to];
    }
    return 1 + std::max(leftScore, rightScore);
    /*while(from != to)
    {
        int curr = findMax(0, w1Size - 1, 1, from, to).second;
        levelRes++;
        int rightFrom = curr + 1;
        int leftTo = curr - 1;
        if(rightFrom > to)
        {
            to = curr - 1;
        }
        else if(leftTo < from)
        {
            from = curr + 1;
        }
        else
        {
            int rightMax = findMax(0, w1Size - 1, 1, rightFrom, to).second;
            int leftMax = findMax(0, w1Size - 1, 1, from, leftTo).second;
                //std::cout << "tuk";

            if(std::max(to - rightMax, rightMax - rightFrom) > std::max(leftTo - leftMax, leftMax - from))
            {
                from = curr + 1;
            }
            else
            {
                to = curr - 1;
            }
        }
        /*if(curr - 1 - from + 1 >= to - (curr + 1) + 1)
        {
            to = curr - 1;
        }
        else
        {
            from = curr + 1;
        }*/
        /*if(from == to)
        {
            levelRes++;
            break;
        }*/
    //}
//    return levelRes;
}

void fillAns()
{
    /*for(int i = 0; i < w1Size; i++)
    {
        for(int j = 0; j < w1Size; j++)
        {
            biggestAns[i][j] = {-1, -1};
        }
    }*/
    for(int k = 0; k < w1Size; k++)
    {
        for(int i = 0; i + k < w1Size; i++)
        {
            ans[i][i + k] = 0;
            if(k == 0)
            {
                ans[i][i] = 1;
            }
            else if(k == 1)
            {
                ans[i][i + k] = 2;
            }
            else
            {
                if(biggestAns[i][i + k].first == -1 && biggestAns[i][i + k].second == -1)
                {
                    biggestAns[i][i + k] = findMax(0, w1Size - 1, 1, i, i + k);
                }
                int curr = biggestAns[i][i + k].second;
                if(curr - 1 < i)
                {
                    //to the right
                    ans[i][i + k] += 1 + ans[curr + 1][i + k];
                }
                else if(curr + 1 > i + k)
                {
                    //to the left
                    ans[i][i + k] += 1 + ans[i][curr - 1];
                }
                else
                {
                    ans[i][i + k] += 1 + std::max(ans[i][curr - 1], ans[curr + 1][i + k]);
                }
            }
        }
    }
}

long long solve(const std::vector<int>& w, const std::vector<int>& S)
{
    //std::vector<int> s1 = S;
    //std::sort(s1.begin(), s1.end());
    w1 = w;
    w1Size = w1.size();
    long long res = 0;
    for(int i = 0; i < w1.size(); i++)
    {
        for(int j = 0; j < w1.size(); j++)
        {
            biggestAns[i][j] = {-1 , -1};
        }
    }
    build_tree(0, w1Size - 1, 1);
    if(S.size() > 10){
        /*for(int i = 0; i < w1.size(); i++)
        {
            for(int j = 0; j < w1.size(); j++)
            {
                ans[i][j] = -1;
            }
        }*/
        fillAns();
    }
    sizeS = S.size();
    for(int i = 0; i < sizeS; i++)
    {
        for(int j = 0; j < sizeS; j++)
        {
            //std::cout << S[i] << "->" << S[j] << " " << levelScore(S[i] - 1, S[j] - 1) << std::endl;
            if(S[i] <= S[j])
            {
                if(sizeS <= 10)
                {
                    res += levelScore(S[i] - 1, S[j] - 1);
                }
                else
                {
                    res += ans[S[i] - 1][S[j] - 1];//levelScore(S[i] - 1, S[j] - 1);
                }
            }
        }
    }
    return res;
}
