#include <vector>
#include <iostream>
#include "lis.h"
#include "lis2.cpp"
static int n;
static std::vector<int> sequence;

static long long num_queries = 0;
static long long max_queries = 0;
static int error_flag = 0;

static int lis(const std::vector<int> &p){
	std::vector<int> v;
	for(int x: p){
		auto it = lower_bound(v.begin(), v.end(), x);
		if(it == v.end()){
			v.push_back(x);
		}
		else{
			*it = x;
		}
	}
	return v.size();
}

int get_lis_length(const std::vector<int> &permutation){
	++num_queries;
	max_queries = std::max(max_queries, num_queries);

	if(permutation.size() != n){
		std::cout << -1 << std::endl;
		exit(0);
	}

	std::vector<int> cnt(n);
	for(int i = 0; i < n; ++i){
		if(permutation[i] < 0 || permutation[i] >= n){
			std::cout << -2 << std::endl;
			exit(0);
		}
		++cnt[permutation[i]];
		if(cnt[permutation[i]] >= 2){
			std::cout << -3 << std::endl;
			exit(0);
		}
	}

	std::vector<int> new_seq(n);
	for(int i = 0; i < n; ++i)
		new_seq[i] = sequence[permutation[i]];
	return lis(new_seq);
}

int main(){
	std::ios::sync_with_stdio(false);
	//std::cin.tie(NULL);

	int correct = true;
	int t;
	std::cin >> t;

	while(t--){
		num_queries = 0;

		std::cin >> n;
		sequence.resize(n);
		for(int i = 0; i < n; ++i){
			std::cin >> sequence[i];
		}

		int position = find_maximum(n);
		correct &= sequence[position] == n - 1;
	}

	if(error_flag){
		std::cout << "Wrong with flag " << error_flag << std::endl;
		return 0;
	}
	if(!correct){
		std::cout << "Wrong answer" << "\n";
		return 0;
	}
	std::cout << "Correct" << " with maximum " << max_queries << " queries." << "\n";
}

/// 3 0 2 4 1
