///#include "Lgrader.cpp"
#include "jumps.h"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const long long INF = 1e18;

int n;
int divisors[MAXN + 5];
long long dp[MAXN + 5];

void eratosthenes()
{
    for (int i = 2; i <= n; ++ i)
    {
        if (!divisors[i])
        {
            divisors[i] = i;
            for (long long j = 1ll * i * i; j <= n; j += i)
            {
                if (!divisors[j]) divisors[j] = i;
            }
        }
    }
}

long long max_prize(vector<int> A)
{
    n = A.size();
    eratosthenes();

    dp[1] = 0;
    for (int i = 2; i <= n; ++ i)
    {
        dp[i] = -INF;
        for (int j = 1; j < i - 1; ++ j)
        {
            dp[i] = max(dp[i], 1ll * A[i - 1] * (i - j) / divisors[i - j] + dp[j]);
        }
    }
    return dp[n];
}
