#include "Lgrader.cpp"
#include "jumps.h"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int MAXJUMPS = 40;
const long long INF = 1e18;

int n;
long long dp[MAXN + 5];
vector< vector<long long> > tree[4 * MAXN + 5];

void build(int v, int l, int r)
{
    tree[v].resize(MAXJUMPS);
    for (int i = 0; i < MAXJUMPS; ++ i)
    {
        tree[v][i].resize(i + 1, -INF);
    }
    if (l == r) return;

    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
}

void update(int x, int y, int v, int l, int r, int pos, int val)
{
    if (l == r)
    {
        tree[v][x][y] = val;
        return;
    }

    int mid = (l + r) / 2;
    if (pos <= mid) update(x, y, 2 * v, l, mid, pos, val);
    else update(x, y, 2 * v + 1, mid + 1, r, pos, val);
    tree[v][x][y] = max(tree[2 * v][x][y], tree[2 * v + 1][x][y]);
}

long long query(int x, int y, int v, int l, int r, int ql, int qr)
{
    if (qr < l or r < ql) return -INF;
    if (ql <= l and r <= qr) return tree[v][x][y];

    int mid = (l + r) / 2;
    return max(query(x, y, 2 * v, l, mid, ql, qr), query(x, y, 2 * v + 1, mid + 1, r, ql, qr));
}

long long max_prize(vector<int> A)
{
    n = A.size();

    build(1, 1, n);

    dp[1] = 0;
    dp[2] = -INF;
    for (int j = 1; j < MAXJUMPS; ++ j)
    {
        update(j - 1, 1 % j, 1, 1, n, 1, dp[1]);
    }
    for (int i = 3; i <= n; ++ i)
    {
        dp[i] = -INF;
        for (int j = 1; ; ++ j)
        {
            if (j >= i - 1) break;
            if (j <= MAXJUMPS)
            {
                int qr = i - j;
                if (j == 1) qr--;
                dp[i] = max(dp[i], query(j - 1, i % j, 1, 1, n, 1, qr) + 1ll * j * A[i - 1]);
            }
            else
            {
                for (int k = 2; ; ++ k)
                {
                    if (j * k < i) dp[i] = max(dp[i], dp[i - j * k] + 1ll * j * A[i - 1]);
                }
            }
        }
        ///cout << dp[i] << endl;

        for (int j = 1; j < MAXJUMPS; ++ j)
        {
            update(j - 1, i % j, 1, 1, n, i, dp[i]);
        }
    }
    return dp[n];
}
